// forkIt.cpp
#include <unistd.h> // sleep(), fork(), execXXX(), pid_t (in sys/types.h)
#include <sys/wait.h> // waitpid()
#include <iostream>
#include <string>

using namespace std;

// print message with current file, line, and function
#define PRINT_MSG(msg) cout << msg << " " << __FILE__ << " " << __LINE__ << " " << __FUNCTION__ << endl;

int main(int argc, char * argv[]) {
  if (argc == 1) {
    cerr << "usage: " << argv[0] << " command args...\n";
    return 1;
  }

  pid_t child_pid = fork(); // child_result == 0, parent_result == PID of child

  if (child_pid == 0) {
    cout << "Executing given program\n";
    // In child, run the given program with given arguments
    execv(argv[1], argv + 1); // first argument is the program, the next one is arguments
    // This code is reached only if execv() fails
    perror("failed to run the program");
    return 1;
  } 

  cout << "PARENT!!!\n";

  // because child did exec(), it won't run the code below
  //
  // wait for the child
  int status;
  waitpid(child_pid, &status, 0);

  cout << "the child process exited with status " << status << "\n";

  return 0;
}
